--- g40.dsl	2007-01-13 23:45:46.000000000 +0000
+++ g40.morebuttons.dsl	2008-10-20 23:23:35.000000000 +0100
@@ -15,7 +15,7 @@
  *     Creator ID       "MSFT"
  *     Creator Revision 0x0100000D (16777229)
  */
-DefinitionBlock ("g40.aml", "DSDT", 1, "IBM   ", "TP-1T   ", 0x00001210)
+DefinitionBlock ("g40.morebuttons.aml", "DSDT", 1, "IBM   ", "TP-1T   ", 0x00001210)
 {
     Scope (_PR)
     {
@@ -2164,7 +2164,7 @@
                         }
                     }
 
-                    Method (_Q03, 0, NotSerialized)
+                    Method (_Q03, 0, NotSerialized) /* Fn-F9 */
                     {
                         If (\_SB.PCI0.LPC.EC.HKEY.MHKK (0x0100))
                         {
@@ -2174,55 +2174,46 @@
                         Noop
                     }
 
-                    Method (_Q04, 0, NotSerialized)
+                    Method (_Q04, 0, NotSerialized) /* Fn-Space */
                     {
+                        \_SB.PCI0.LPC.EC.HKEY.MHKQ (0x1020)
                         \CMOS (0x0B)
                     }
 
-                    Method (_Q0A, 0, NotSerialized)
+                    Method (_Q0A, 0, NotSerialized) /* Fn-Home */
                     {
+                        \_SB.PCI0.LPC.EC.HKEY.MHKQ (0x1012)
                         \CMOS (0x04)
                     }
 
-                    Method (_Q0B, 0, NotSerialized)
+                    Method (_Q0B, 0, NotSerialized) /* Fn-End */
                     {
+                        \_SB.PCI0.LPC.EC.HKEY.MHKQ (0x1013)
                         \CMOS (0x05)
                     }
 
-                    Method (_Q0C, 0, NotSerialized)
+                    Method (_Q0C, 0, NotSerialized) /* Fn-F3 */
                     {
                         \_SB.PCI0.LPC.EC.HKEY.MHKQ (0x1003)
                     }
 
-                    Method (_Q0D, 0, NotSerialized)
+                    Method (_Q0D, 0, NotSerialized) /* Fn-F4 */
                     {
-                        If (\_SB.PCI0.LPC.EC.HKEY.DHKC)
-                        {
-                            \_SB.PCI0.LPC.EC.HKEY.MHKQ (0x1004)
-                        }
-                        Else
-                        {
-                            Notify (\_SB.SLPB, 0x80)
-                        }
+                        \_SB.PCI0.LPC.EC.HKEY.MHKQ (0x1004)
                     }
 
-                    Method (_Q0E, 0, NotSerialized)
+                    Method (_Q0E, 0, NotSerialized) /* Fn-F5 */
                     {
-                        If (\_SB.PCI0.LPC.EC.HKEY.MHKK (0x10))
-                        {
-                            \_SB.PCI0.LPC.EC.HKEY.MHKQ (0x1005)
-                        }
-                        Else
-                        {
-                        }
+                        \_SB.PCI0.LPC.EC.HKEY.MHKQ (0x1005)
                     }
 
-                    Method (_Q0F, 0, NotSerialized)
+                    Method (_Q0F, 0, NotSerialized) /* Access IBM */
                     {
+                        \_SB.PCI0.LPC.EC.HKEY.MHKQ (0x2000)
                         \CMOS (0x03)
                     }
 
-                    Method (_Q10, 0, NotSerialized)
+                    Method (_Q10, 0, NotSerialized) /* Fn-F7 */
                     {
                         If (\_SB.PCI0.LPC.EC.HKEY.MHKK (0x40))
                         {
@@ -2234,7 +2225,7 @@
                         }
                     }
 
-                    Method (_Q11, 0, NotSerialized)
+                    Method (_Q11, 0, NotSerialized) /* Fn-F8 */
                     {
                         If (\_SB.PCI0.LPC.EC.HKEY.MHKK (0x80))
                         {
@@ -2242,31 +2233,31 @@
                         }
                         Else
                         {
-                            If (LNot (\WNTF))
-                            {
-                                VEXP ()
-                            }
+                            VEXP ()
                         }
                     }
 
-                    Method (_Q12, 0, NotSerialized)
+                    Method (_Q12, 0, NotSerialized) /* Vol Down */
                     {
+                        \_SB.PCI0.LPC.EC.HKEY.MHKQ (0x2001)
                         \CMOS (0x00)
                         BEEP (0x0B)
                     }
 
-                    Method (_Q13, 0, NotSerialized)
+                    Method (_Q13, 0, NotSerialized) /* Vol Up */
                     {
+                        \_SB.PCI0.LPC.EC.HKEY.MHKQ (0x2002)
                         \CMOS (0x01)
                         BEEP (0x0B)
                     }
 
-                    Method (_Q14, 0, NotSerialized)
+                    Method (_Q14, 0, NotSerialized) /* Mute */
                     {
+                        \_SB.PCI0.LPC.EC.HKEY.MHKQ (0x2003)
                         \CMOS (0x02)
                     }
 
-                    Method (_Q15, 0, NotSerialized)
+                    Method (_Q15, 0, NotSerialized) /* Fn-F12 */
                     {
                         \_SB.PCI0.LPC.EC.HKEY.MHKQ (0x100C)
                     }
